#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

void prefsum(int *v,int rank, int size){
  int j;
  MPI_Status st;

  printf("rank:%d:v:%d\n",rank,*v);

  for (j=1;j<size;j*=2){
    int l;
    
    if (rank<size-j)
      MPI_Send(v,1,MPI_INT,rank+j,1,MPI_COMM_WORLD);
 
    printf("%d:%d:%d\n",rank,j,*v);

    if (rank-j>=0){
      MPI_Recv(&l,1,MPI_INT,rank-j,1,MPI_COMM_WORLD,&st);
      *v+=l;
    }
  }
} 

int
main(int argc, char *argv[])
{
  int rank,size;
  int v,oldv,j,*vec;
  MPI_Status st;

  MPI_Init(&argc, &argv);
  oldv=v = rand();
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  vec=(int *) malloc(size*sizeof(int));
  if (rank==0)
	for (j=0;j<size;j++)  vec[j]=rand()%size;
  MPI_Scatter(vec,1,MPI_INT,&v,1,MPI_INT,0,MPI_COMM_WORLD);

	
  oldv=v;
  printf("start:%d:%d\n",rank,v);
  prefsum(&v,rank,size);

  printf("rank %d:oldv %d:max %d\n",rank,oldv,v);


  MPI_Finalize();
}


 

